// $Id: $
#ifndef ALINKREADER_H 
#define ALINKREADER_H 1

// Include files
// from Gaudi
#include "GaudiAlg/GaudiAlgorithm.h"
#include "VeloTELL1Data.h"
#include "EvtInfo.h"

/** @class ALinkReader ALinkReader.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-04-24
 */

class ALinkReader : public GaudiAlgorithm {
public: 
  /// Standard constructor
  ALinkReader( const std::string& name, ISvcLocator* pSvcLocator );

  virtual ~ALinkReader( ); ///< Destructor

  virtual StatusCode initialize();    ///< Algorithm initialization
  virtual StatusCode execute   ();    ///< Algorithm execution
  virtual StatusCode finalize  ();    ///< Algorithm finalization

protected:

  StatusCode getData();
  StatusCode getAllSensors();
  StatusCode getOneSensor();

private:

  std::string m_decodedADCLoc;
  std::string m_decodedPedLoc;
  std::string m_decodedHeaderLoc;
  std::string m_evtInfoLoc;
  VeloTELL1Datas* m_decodedADCs;
  VeloTELL1Datas* m_decodedPeds;
  VeloTELL1Datas* m_decodedHeaders;
  EvtInfos* m_evtInfos;

};
#endif // ALINKREADER_H
