// $Id: $
#ifndef DECODECONF_H 
#define DECODECONF_H 1

// Include files

/** @class DecodeConf DecodeConf.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-03-23
 */

namespace VeloFullConf
{
  // general parameters describing layout of the data section
  enum sections{
    SectionBShift=1,
    SectionCShift,
    SectionsPerBlock,
    EventInfoLength=8,
    NumberOfALinks=64,
    PPFPGAPedBlock=192,
    PPFPGADataSection=216
  };
  // parameters related to organization of the sections within data stream
  enum blocks{
    NumberOfPPFPGA=4,
    PPFPGADataBlock=224
  };
  // banks types  
  enum BankTypes{
    VeloFull=18,
    VeloError=29,
    VeloPedestal=30,
    VeloHeader=40,  // this is not a real bank! 
    VeloEvtInfo=50   // added for the sake of simplicity during decoding
  };
  // details related to organization of the words within the data section
  enum Decoding{
    ALinkPerDataStream=2,
    DataStreamPerSection=3,
    ADCHeaders=4,
    ADCShift=10,
    channels=32,
    ALinkShift=36,
    ADCMask=0x000003ff
  };
  // entry dedicated to cope with asymmetric section C
  enum emptySection{
    emptyField=2
  };
  
}
#endif // DECODECONF_H
//
