// $Id: $
#ifndef VELOTELL1ALG_DECODER_H 
#define VELOTELL1ALG_DECODER_H 1

// Include files
#include "VeloFullBank.h"
#include "DecodeConf.h"
#include "DecodeCore.h"

/** @class Decoder Decoder.h Decoder.h
 *  
 *
 *  @author Tomasz Szumlak
 *  @date   2006-04-11
 */

using namespace DecodeCore;

class Decoder {

  enum initialShifts{
    NoShift=0,
    EmptyData=2,
    ADCShift=4
  };
  
public: 

  /// Standard constructor
  Decoder(const int decoderType);
  virtual ~Decoder( ); ///< Destructor
  dataVec& decode(VeloFullBank* inData);
  
protected:

  void decoderIni(const int decoderType);

private:

  int m_initialShift;  // if decoding adcs skip headers
  int m_dataLenght;    // lenght of the ALink
  int m_wordsToDecode; // words to decode
  dataVec m_decodedData;    

};
#endif // VELOTELL1ALG_DECODER_H
//
